//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml.dll;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Lino.dll;


using System;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Reflection;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.WesternSpirits;
using Produmex.Sbo.Logex.WesternSpirits.Generators.BarcodeController;

namespace AddUpdateScript
{
    class Program
    {
        static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US_320;ExtraDb=PMX_SBODemo_US_320;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000";
        //static string SCRIPT_ROOT = @"..\WorkflowScripts";

        static void Main(string[] args)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                    dbConn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    //Console.WriteLine("Workflows");

                    //AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.MAIN_FLOW, "MainReceptionWSBScript",
                    //    SCRIPT_ROOT + @"\WorkflowScript_MainReceptionWSBScript\WorkflowScript_MainReceptionWSBScript.cs", dbConn);

                    //AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.SUB_FLOW, "ReceptionWSBScript",
                    //    SCRIPT_ROOT + @"\WorkflowScript_ReceptionWSBScript\WorkflowScript_ReceptionWSBScript.cs", dbConn);





                    Console.WriteLine("Extensions");

                    AddUpdateExtension(
                         WesternSpiritsBarcodeController.IDs.ExtCode,
                         "IBarcodeController - WesternSpirits",
                         typeof(WesternSpiritsBarcodeController),
                         Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IBARCODECONTROLLER,
                         dbConn
                         );



                }


                //Complete transaction
                scope.Complete();
            }

            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");


                    PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);


                    updateProv.AddUpdateExtension(
                       Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtCode,
                       "Western Spirits - Production receipt interface",
                       typeof(Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface),
                       Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOPRODUCTIONRECEIPT);

                    //updateProv.AddUpdateExtensionParameter(Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtParamWindowsPrinterName,
                    //  "Windows printer name",
                    //  Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtCode,
                    //  Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                    //  "",
                    //  Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtParamWindowsPrinterName);

                    //updateProv.AddUpdateExtensionParameter(Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtParamReportKey,
                    //  "Report key",
                    //  Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtCode,
                    //  Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR,
                    //  "",
                    //  Produmex.Sbo.Logex.WesternSpirits.Extensions.Interfacing.SboProductionReceiptInterface.IDs.ExtParamReportKey);

                }

                //Complete transaction
                scope.Complete();
            }




            Console.WriteLine("Done ...");
        }



        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnectionSql conn)
        {
            PmxExtensionProvider prov = new PmxExtensionProvider(conn);
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO(code);
                if (extension == null)
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
                if (newBO)
                {
                    prov.AddBO(extension);
                }
                else
                {
                    prov.UpdateBO(extension, false, false);
                }
            }
            finally
            {
                if (extension != null) extension.Dispose();
            }
        }

        


        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }



        }
    }
}
